unit SwFont;
{$DEFINE Separate8x16}
interface

Procedure LoadFont(Rows:Byte);

Procedure GetVideoParams(Var FontSize,Rows,Cols:Byte);

Procedure SetGraphFont0;
implementation
Procedure Font8x14; external;
{$L FONT8x14.OBJ}
Procedure Font8x8; external;
{$L FONT8x8.OBJ}
{$IFDEF SEPARATE8X16}
 Procedure Font8x16;external;
 {$L FONT8X16.OBJ}
{$ENDIF}
Procedure LoadFont(Rows:Byte);
Type TFont=Array[0..255,1..14] of Byte;
     TFont16=Array[0..255,0..15] of Byte;
     PFont=^TFont;
     PFont16=^TFont16;
{$IFNDEF SEPARATE8X16}
var Font8x16:PFont16;
Procedure ExpandFont(Source:PFont;Dest:PFont16);
var i,j:Integer;
Const Pseudogr:Set of 0..255=[176..223];
begin
 For i:=0 to 255 do
  begin
   For j:=1 to 14 do
    Dest^[i,j]:=Source^[i,j];
   if i in Pseudogr then
    begin
     Dest^[i,0]:=Dest^[i,2];
     Dest^[i,15]:=Dest^[i,13];
    end
    else
     begin
      Dest^[i,0]:=0;
      Dest^[i,15]:=0;
     end;
  end;
end;
{$ENDIF}
Procedure DoLoad(Font:Pointer;Rows:Byte);assembler;
var Cursor:Word;
asm
 MOV AH,3
 MOV BH,0
 Int 10H
 MOV Cursor,CX
 MOV AX,1100H
 MOV CX,128
 Mov DX,128
 MOV Bl,0
 MOV BH,Rows
 Mov AX,80H
 Mul BH
 PUSH BP
 LES BP,Font
 ADD BP,AX
 MOV AX,1100H
 INT 10H
 POP BP
 MOV CX,Cursor
 MOV AH,1
 INT 10H
end;
begin
 Case Rows of
 8:DoLoad(@Font8x8,8);
 14:DoLoad(@Font8x14,14);
 16:
{$IFDEF SEPARATE8X16}
     DoLoad(@Font8x16,16);
{$ELSE}
     begin
      GetMem(Font8x16,4096);
      ExpandFont(PFont(@Font8x14),Font8x16);
      DoLoad(Font8x16,16);
      FreeMem(Font8x16,4096);
     end;
{$ENDIF}
 end;
end;
Procedure GetVideoParams(Var FontSize,Rows,Cols:Byte);assembler;
asm
 MOV AH,0FH;
 INT 10H
 Les DI,Cols
 MOV ES:[DI],AH
 MOV DL,0
 MOV AX,1130H
 INT 10H
 Les Di,Rows
 Mov Es:[DI],DL
 Les Di,FontSize
 Mov ES:[DI],CL
end;


var OldExit:Pointer;
    Old1F:Pointer;
Procedure MyExit;Far;
begin
 Asm
   Push DS
   LDS  DX,Old1F
   MOV AX,251FH
   INT 21H
   POP DS
 end;
 ExitProc:=OldExit;
end;
Procedure SetGraphFont0;
begin
 OldExit:=ExitPRoc;
 ExitProc:=@MyExit;
 asm
  MOV AX,351FH
  INT 21H
  MOV Old1F.Word[0],BX
  MOV Old1F.Word[2],ES
  PUSH DS
  PUSH CS
  POP DS
  MOV DX,Offset Font8x8+1024
  MOV AX,251FH
  INT 21H
  POP DS
 end;
end;
end.